(function (_, Kotlin) {
  'use strict';
  var Enum = Kotlin.kotlin.Enum;
  var Kind_CLASS = Kotlin.Kind.CLASS;
  var throwISE = Kotlin.throwISE;
  var Kind_OBJECT = Kotlin.Kind.OBJECT;
  var listOf = Kotlin.kotlin.collections.listOf_i5x0yv$;
  var ArrayList_init = Kotlin.kotlin.collections.ArrayList_init_mqih57$;
  var lazy = Kotlin.kotlin.lazy_klfg04$;
  var ArrayList = Kotlin.kotlin.collections.ArrayList;
  var to = Kotlin.kotlin.to_ujzrz7$;
  var Unit = Kotlin.kotlin.Unit;
  var ensureNotNull = Kotlin.ensureNotNull;
  var throwCCE = Kotlin.throwCCE;
  var emptyList = Kotlin.kotlin.collections.emptyList_287e2$;
  var toMap = Kotlin.kotlin.collections.toMap_6hr0sd$;
  var equals = Kotlin.equals;
  var Error_init = Kotlin.kotlin.Error_init_pdl1vj$;
  var Kind_INTERFACE = Kotlin.Kind.INTERFACE;
  var IllegalArgumentException_init = Kotlin.kotlin.IllegalArgumentException_init_pdl1vj$;
  var IllegalArgumentException = Kotlin.kotlin.IllegalArgumentException;
  var mapOf = Kotlin.kotlin.collections.mapOf_qfcya0$;
  AttributeType.prototype = Object.create(Enum.prototype);
  AttributeType.prototype.constructor = AttributeType;
  Matrix3.prototype = Object.create(ArrayList.prototype);
  Matrix3.prototype.constructor = Matrix3;
  Matrix4.prototype = Object.create(ArrayList.prototype);
  Matrix4.prototype.constructor = Matrix4;
  Triangle.prototype = Object.create(Object_0.prototype);
  Triangle.prototype.constructor = Triangle;
  InvalidVectorOperation.prototype = Object.create(IllegalArgumentException.prototype);
  InvalidVectorOperation.prototype.constructor = InvalidVectorOperation;
  function AttributeType(name, ordinal, value) {
    Enum.call(this);
    this.value = value;
    this.name$ = name;
    this.ordinal$ = ordinal;
  }
  function AttributeType_initFields() {
    AttributeType_initFields = function () {
    };
    AttributeType$ARRAY_BUFFER_instance = new AttributeType('ARRAY_BUFFER', 0, 34962);
  }
  var AttributeType$ARRAY_BUFFER_instance;
  function AttributeType$ARRAY_BUFFER_getInstance() {
    AttributeType_initFields();
    return AttributeType$ARRAY_BUFFER_instance;
  }
  AttributeType.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'AttributeType',
    interfaces: [Enum]
  };
  function AttributeType$values() {
    return [AttributeType$ARRAY_BUFFER_getInstance()];
  }
  AttributeType.values = AttributeType$values;
  function AttributeType$valueOf(name) {
    switch (name) {
      case 'ARRAY_BUFFER':
        return AttributeType$ARRAY_BUFFER_getInstance();
      default:throwISE('No enum constant AttributeType.' + name);
    }
  }
  AttributeType.valueOf_61zpoe$ = AttributeType$valueOf;
  function Attribute(name, type, mapper) {
    this.name = name;
    this.type = type;
    this.mapper = mapper;
  }
  Attribute.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Attribute',
    interfaces: []
  };
  Attribute.prototype.component1 = function () {
    return this.name;
  };
  Attribute.prototype.component2 = function () {
    return this.type;
  };
  Attribute.prototype.component3 = function () {
    return this.mapper;
  };
  Attribute.prototype.copy_b2azpw$ = function (name, type, mapper) {
    return new Attribute(name === void 0 ? this.name : name, type === void 0 ? this.type : type, mapper === void 0 ? this.mapper : mapper);
  };
  Attribute.prototype.toString = function () {
    return 'Attribute(name=' + Kotlin.toString(this.name) + (', type=' + Kotlin.toString(this.type)) + (', mapper=' + Kotlin.toString(this.mapper)) + ')';
  };
  Attribute.prototype.hashCode = function () {
    var result = 0;
    result = result * 31 + Kotlin.hashCode(this.name) | 0;
    result = result * 31 + Kotlin.hashCode(this.type) | 0;
    result = result * 31 + Kotlin.hashCode(this.mapper) | 0;
    return result;
  };
  Attribute.prototype.equals = function (other) {
    return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && (Kotlin.equals(this.name, other.name) && Kotlin.equals(this.type, other.type) && Kotlin.equals(this.mapper, other.mapper)))));
  };
  function AttributeInfo(name, position, type, buffer, mapper) {
    this.name = name;
    this.position = position;
    this.type = type;
    this.buffer = buffer;
    this.mapper = mapper;
  }
  AttributeInfo.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'AttributeInfo',
    interfaces: []
  };
  AttributeInfo.prototype.component1 = function () {
    return this.name;
  };
  AttributeInfo.prototype.component2 = function () {
    return this.position;
  };
  AttributeInfo.prototype.component3 = function () {
    return this.type;
  };
  AttributeInfo.prototype.component4 = function () {
    return this.buffer;
  };
  AttributeInfo.prototype.component5 = function () {
    return this.mapper;
  };
  AttributeInfo.prototype.copy_t0zzcu$ = function (name, position, type, buffer, mapper) {
    return new AttributeInfo(name === void 0 ? this.name : name, position === void 0 ? this.position : position, type === void 0 ? this.type : type, buffer === void 0 ? this.buffer : buffer, mapper === void 0 ? this.mapper : mapper);
  };
  AttributeInfo.prototype.toString = function () {
    return 'AttributeInfo(name=' + Kotlin.toString(this.name) + (', position=' + Kotlin.toString(this.position)) + (', type=' + Kotlin.toString(this.type)) + (', buffer=' + Kotlin.toString(this.buffer)) + (', mapper=' + Kotlin.toString(this.mapper)) + ')';
  };
  AttributeInfo.prototype.hashCode = function () {
    var result = 0;
    result = result * 31 + Kotlin.hashCode(this.name) | 0;
    result = result * 31 + Kotlin.hashCode(this.position) | 0;
    result = result * 31 + Kotlin.hashCode(this.type) | 0;
    result = result * 31 + Kotlin.hashCode(this.buffer) | 0;
    result = result * 31 + Kotlin.hashCode(this.mapper) | 0;
    return result;
  };
  AttributeInfo.prototype.equals = function (other) {
    return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && (Kotlin.equals(this.name, other.name) && Kotlin.equals(this.position, other.position) && Kotlin.equals(this.type, other.type) && Kotlin.equals(this.buffer, other.buffer) && Kotlin.equals(this.mapper, other.mapper)))));
  };
  function Matrix3(a, b, c, d, e, f, g, h, i) {
    Matrix3$Companion_getInstance();
    ArrayList_init(listOf([a, b, c, d, e, f, g, h, i]), this);
    this.a = a;
    this.b = b;
    this.c = c;
    this.d = d;
    this.e = e;
    this.f = f;
    this.g = g;
    this.h = h;
    this.i = i;
    this.determinant_xkmr9b$_0 = lazy(Matrix3$determinant$lambda(this));
  }
  Object.defineProperty(Matrix3.prototype, 'determinant', {
    get: function () {
      return this.determinant_xkmr9b$_0.value;
    }
  });
  function Matrix3$Companion() {
    Matrix3$Companion_instance = this;
  }
  Matrix3$Companion.prototype.identity = function () {
    return new Matrix3(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0);
  };
  Matrix3$Companion.prototype.translation = function (translation) {
    return new Matrix3(1.0, 0.0, translation.x, 0.0, 1.0, translation.y, 0.0, 0.0, 1.0);
  };
  Matrix3$Companion.prototype.scale = function (scale) {
    return new Matrix3(scale.x, 0.0, 0.0, 0.0, scale.y, 0.0, 0.0, 0.0, 1.0);
  };
  Matrix3$Companion.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'Companion',
    interfaces: []
  };
  var Matrix3$Companion_instance = null;
  function Matrix3$Companion_getInstance() {
    if (Matrix3$Companion_instance === null) {
      new Matrix3$Companion();
    }
    return Matrix3$Companion_instance;
  }
  function Matrix3$determinant$lambda(this$Matrix3) {
    return function () {
      return this$Matrix3.a * (this$Matrix3.e * this$Matrix3.i - this$Matrix3.h * this$Matrix3.f) - this$Matrix3.b * (this$Matrix3.d * this$Matrix3.i - this$Matrix3.g * this$Matrix3.f) + this$Matrix3.c * (this$Matrix3.d * this$Matrix3.h - this$Matrix3.g * this$Matrix3.e);
    };
  }
  Matrix3.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Matrix3',
    interfaces: [ArrayList]
  };
  function Matrix3_init(scale, translation, $this) {
    $this = $this || Object.create(Matrix3.prototype);
    Matrix3.call($this, scale.x, 0.0, translation.x, 0.0, scale.y, translation.y, 0.0, 0.0, 1.0);
    return $this;
  }
  Matrix3.prototype.component1 = function () {
    return this.a;
  };
  Matrix3.prototype.component2 = function () {
    return this.b;
  };
  Matrix3.prototype.component3 = function () {
    return this.c;
  };
  Matrix3.prototype.component4 = function () {
    return this.d;
  };
  Matrix3.prototype.component5 = function () {
    return this.e;
  };
  Matrix3.prototype.component6 = function () {
    return this.f;
  };
  Matrix3.prototype.component7 = function () {
    return this.g;
  };
  Matrix3.prototype.component8 = function () {
    return this.h;
  };
  Matrix3.prototype.component9 = function () {
    return this.i;
  };
  Matrix3.prototype.copy_b32tf5$ = function (a, b, c, d, e, f, g, h, i) {
    return new Matrix3(a === void 0 ? this.a : a, b === void 0 ? this.b : b, c === void 0 ? this.c : c, d === void 0 ? this.d : d, e === void 0 ? this.e : e, f === void 0 ? this.f : f, g === void 0 ? this.g : g, h === void 0 ? this.h : h, i === void 0 ? this.i : i);
  };
  Matrix3.prototype.toString = function () {
    return 'Matrix3(a=' + Kotlin.toString(this.a) + (', b=' + Kotlin.toString(this.b)) + (', c=' + Kotlin.toString(this.c)) + (', d=' + Kotlin.toString(this.d)) + (', e=' + Kotlin.toString(this.e)) + (', f=' + Kotlin.toString(this.f)) + (', g=' + Kotlin.toString(this.g)) + (', h=' + Kotlin.toString(this.h)) + (', i=' + Kotlin.toString(this.i)) + ')';
  };
  Matrix3.prototype.hashCode = function () {
    var result = 0;
    result = result * 31 + Kotlin.hashCode(this.a) | 0;
    result = result * 31 + Kotlin.hashCode(this.b) | 0;
    result = result * 31 + Kotlin.hashCode(this.c) | 0;
    result = result * 31 + Kotlin.hashCode(this.d) | 0;
    result = result * 31 + Kotlin.hashCode(this.e) | 0;
    result = result * 31 + Kotlin.hashCode(this.f) | 0;
    result = result * 31 + Kotlin.hashCode(this.g) | 0;
    result = result * 31 + Kotlin.hashCode(this.h) | 0;
    result = result * 31 + Kotlin.hashCode(this.i) | 0;
    return result;
  };
  Matrix3.prototype.equals = function (other) {
    return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && (Kotlin.equals(this.a, other.a) && Kotlin.equals(this.b, other.b) && Kotlin.equals(this.c, other.c) && Kotlin.equals(this.d, other.d) && Kotlin.equals(this.e, other.e) && Kotlin.equals(this.f, other.f) && Kotlin.equals(this.g, other.g) && Kotlin.equals(this.h, other.h) && Kotlin.equals(this.i, other.i)))));
  };
  function Matrix3Identity() {
    return Matrix3$Companion_getInstance().identity();
  }
  function Matrix3Translation(translation) {
    return Matrix3$Companion_getInstance().translation(translation);
  }
  function Matrix3Scale(scale) {
    return Matrix3$Companion_getInstance().scale(scale);
  }
  function transpose($receiver) {
    return new Matrix3($receiver.a, $receiver.d, $receiver.g, $receiver.b, $receiver.e, $receiver.h, $receiver.c, $receiver.f, $receiver.i);
  }
  function adjugate($receiver) {
    var it = transpose($receiver);
    return new Matrix3(it.e * it.i - it.h * it.f, -(it.d * it.i - it.g * it.f), it.d * it.h - it.g * it.e, -(it.b * it.i - it.h * it.c), it.a * it.i - it.g * it.c, -(it.a * it.h - it.g * it.b), it.b * it.f - it.e * it.c, -(it.a * it.f - it.d * it.c), it.a * it.e - it.d * it.b);
  }
  function inverse($receiver) {
    var it = $receiver.determinant;
    return it !== 0.0 ? div(adjugate($receiver), it) : Matrix3$Companion_getInstance().identity();
  }
  function div($receiver, v) {
    return new Matrix3($receiver.a / v, $receiver.b / v, $receiver.c / v, $receiver.d / v, $receiver.e / v, $receiver.f / v, $receiver.g / v, $receiver.h / v, $receiver.i / v);
  }
  function times($receiver, v) {
    return new Vector2($receiver.a * v.x + $receiver.b * v.y + $receiver.c, $receiver.d * v.x + $receiver.e * v.y + $receiver.f);
  }
  function times_0($receiver, m) {
    return new Matrix3($receiver.a * m.a + $receiver.b * m.d + $receiver.c * m.g, $receiver.a * m.b + $receiver.b * m.e + $receiver.c * m.h, $receiver.a * m.c + $receiver.b * m.f + $receiver.c * m.i, $receiver.d * m.a + $receiver.e * m.d + $receiver.f * m.g, $receiver.d * m.b + $receiver.e * m.e + $receiver.f * m.h, $receiver.d * m.c + $receiver.e * m.f + $receiver.f * m.i, $receiver.g * m.a + $receiver.h * m.d + $receiver.i * m.g, $receiver.g * m.b + $receiver.h * m.e + $receiver.i * m.h, $receiver.g * m.c + $receiver.h * m.f + $receiver.i * m.i);
  }
  function translate($receiver, translation) {
    return times_0($receiver, Matrix3$Companion_getInstance().translation(translation));
  }
  function scale($receiver, scale) {
    return times_0($receiver, Matrix3$Companion_getInstance().scale(scale));
  }
  function Matrix4(a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p) {
    Matrix4$Companion_getInstance();
    ArrayList_init(listOf([a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p]), this);
    this.a = a;
    this.b = b;
    this.c = c;
    this.d = d;
    this.e = e;
    this.f = f;
    this.g = g;
    this.h = h;
    this.i = i;
    this.j = j;
    this.k = k;
    this.l = l;
    this.m = m;
    this.n = n;
    this.o = o;
    this.p = p;
    this.determinant_t3hf6o$_0 = lazy(Matrix4$determinant$lambda(this));
  }
  Object.defineProperty(Matrix4.prototype, 'determinant', {
    get: function () {
      return this.determinant_t3hf6o$_0.value;
    }
  });
  Matrix4.prototype.transpose = function () {
    return new Matrix4(this.a, this.e, this.i, this.m, this.b, this.f, this.j, this.n, this.c, this.g, this.k, this.o, this.d, this.h, this.l, this.p);
  };
  Matrix4.prototype.inverse = function () {
    return new Matrix4((this.f * this.k * this.p + this.g * this.l * this.n + this.h * this.j * this.o - this.f * this.l * this.o - this.g * this.j * this.p - this.h * this.k * this.n) / this.determinant, (this.b * this.l * this.o + this.c * this.j * this.p + this.d * this.k * this.n - this.b * this.k * this.p - this.c * this.l * this.n - this.d * this.j * this.o) / this.determinant, (this.b * this.g * this.p + this.c * this.h * this.n + this.d * this.f * this.o - this.b * this.h * this.o - this.c * this.f * this.p - this.d * this.g * this.n) / this.determinant, (this.b * this.h * this.k + this.c * this.f * this.l + this.d * this.g * this.j - this.b * this.g * this.l - this.c * this.h * this.j - this.d * this.f * this.k) / this.determinant, (this.e * this.l * this.o + this.g * this.i * this.p + this.h * this.k * this.m - this.e * this.k * this.p - this.g * this.l * this.m - this.h * this.i * this.o) / this.determinant, (this.a * this.k * this.p + this.c * this.l * this.m + this.d * this.i * this.o - this.a * this.l * this.o - this.c * this.i * this.p - this.d * this.k * this.m) / this.determinant, (this.a * this.h * this.o + this.c * this.e * this.p + this.d * this.g * this.m - this.a * this.g * this.p - this.c * this.h * this.m - this.d * this.e * this.o) / this.determinant, (this.a * this.g * this.l + this.c * this.h * this.i + this.d * this.e * this.k - this.a * this.h * this.k - this.c * this.e * this.l - this.d * this.g * this.i) / this.determinant, (this.e * this.j * this.p + this.f * this.l * this.m + this.h * this.i * this.n - this.e * this.l * this.n - this.f * this.i * this.p - this.h * this.j * this.m) / this.determinant, (this.a * this.l * this.n + this.b * this.i * this.p + this.d * this.j * this.m - this.a * this.j * this.p - this.b * this.l * this.m - this.d * this.i * this.n) / this.determinant, (this.a * this.f * this.p + this.b * this.h * this.m + this.d * this.e * this.n - this.a * this.h * this.n - this.b * this.e * this.p - this.d * this.f * this.m) / this.determinant, (this.a * this.h * this.j + this.b * this.e * this.l + this.d * this.f * this.i - this.a * this.f * this.l - this.b * this.h * this.i - this.d * this.e * this.j) / this.determinant, (this.e * this.k * this.n + this.f * this.i * this.o + this.g * this.j * this.m - this.e * this.j * this.l - this.f * this.k * this.m - this.g * this.i * this.n) / this.determinant, (this.a * this.j * this.o + this.b * this.k * this.m + this.c * this.i * this.n - this.a * this.k * this.n - this.b * this.i * this.o - this.c * this.j * this.m) / this.determinant, (this.a * this.g * this.n + this.b * this.e * this.o + this.c * this.f * this.m - this.a * this.f * this.o - this.b * this.g * this.m - this.c * this.e * this.n) / this.determinant, (this.a * this.f * this.k + this.b * this.g * this.i + this.c * this.e * this.j - this.a * this.g * this.j - this.b * this.e * this.k - this.c * this.f * this.i) / this.determinant);
  };
  function Matrix4$Companion() {
    Matrix4$Companion_instance = this;
  }
  Matrix4$Companion.prototype.identity = function () {
    return new Matrix4(1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
  };
  Matrix4$Companion.prototype.translation_x47bqo$ = function (translation) {
    return new Matrix4(1.0, 0.0, 0.0, translation.x, 0.0, 1.0, 0.0, translation.y, 0.0, 0.0, 1.0, translation.z, 0.0, 0.0, 0.0, 1.0);
  };
  Matrix4$Companion.prototype.scale_x47bqo$ = function (scale) {
    return new Matrix4(scale.x, 0.0, 0.0, 0.0, 0.0, scale.y, 0.0, 0.0, 0.0, 0.0, scale.z, 0.0, 0.0, 0.0, 0.0, 1.0);
  };
  Matrix4$Companion.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'Companion',
    interfaces: []
  };
  var Matrix4$Companion_instance = null;
  function Matrix4$Companion_getInstance() {
    if (Matrix4$Companion_instance === null) {
      new Matrix4$Companion();
    }
    return Matrix4$Companion_instance;
  }
  function Matrix4$determinant$lambda(this$Matrix4) {
    return function () {
      return this$Matrix4.a * this$Matrix4.f * this$Matrix4.k * this$Matrix4.p + this$Matrix4.a * this$Matrix4.g * this$Matrix4.l * this$Matrix4.n + this$Matrix4.a * this$Matrix4.h * this$Matrix4.j * this$Matrix4.o + this$Matrix4.b * this$Matrix4.e * this$Matrix4.l * this$Matrix4.o + this$Matrix4.b * this$Matrix4.g * this$Matrix4.i * this$Matrix4.p + this$Matrix4.b * this$Matrix4.h * this$Matrix4.k * this$Matrix4.m + this$Matrix4.c * this$Matrix4.e * this$Matrix4.j * this$Matrix4.p + this$Matrix4.c * this$Matrix4.f * this$Matrix4.l * this$Matrix4.m + this$Matrix4.c * this$Matrix4.h * this$Matrix4.i * this$Matrix4.n + this$Matrix4.d * this$Matrix4.e * this$Matrix4.k * this$Matrix4.n + this$Matrix4.d * this$Matrix4.f * this$Matrix4.i * this$Matrix4.o + this$Matrix4.d * this$Matrix4.g * this$Matrix4.j * this$Matrix4.m - this$Matrix4.a * this$Matrix4.f * this$Matrix4.l * this$Matrix4.o - this$Matrix4.a * this$Matrix4.g * this$Matrix4.j * this$Matrix4.p - this$Matrix4.a * this$Matrix4.h * this$Matrix4.k * this$Matrix4.n - this$Matrix4.b * this$Matrix4.e * this$Matrix4.k * this$Matrix4.p - this$Matrix4.b * this$Matrix4.g * this$Matrix4.l * this$Matrix4.m - this$Matrix4.b * this$Matrix4.h * this$Matrix4.i * this$Matrix4.o - this$Matrix4.c * this$Matrix4.e * this$Matrix4.l * this$Matrix4.n - this$Matrix4.c * this$Matrix4.f * this$Matrix4.i * this$Matrix4.p - this$Matrix4.c * this$Matrix4.h * this$Matrix4.j * this$Matrix4.m - this$Matrix4.d * this$Matrix4.e * this$Matrix4.j * this$Matrix4.o - this$Matrix4.d * this$Matrix4.f * this$Matrix4.k * this$Matrix4.m - this$Matrix4.d * this$Matrix4.g * this$Matrix4.i * this$Matrix4.n;
    };
  }
  Matrix4.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Matrix4',
    interfaces: [ArrayList]
  };
  Matrix4.prototype.component1 = function () {
    return this.a;
  };
  Matrix4.prototype.component2 = function () {
    return this.b;
  };
  Matrix4.prototype.component3 = function () {
    return this.c;
  };
  Matrix4.prototype.component4 = function () {
    return this.d;
  };
  Matrix4.prototype.component5 = function () {
    return this.e;
  };
  Matrix4.prototype.component6 = function () {
    return this.f;
  };
  Matrix4.prototype.component7 = function () {
    return this.g;
  };
  Matrix4.prototype.component8 = function () {
    return this.h;
  };
  Matrix4.prototype.component9 = function () {
    return this.i;
  };
  Matrix4.prototype.component10 = function () {
    return this.j;
  };
  Matrix4.prototype.component11 = function () {
    return this.k;
  };
  Matrix4.prototype.component12 = function () {
    return this.l;
  };
  Matrix4.prototype.component13 = function () {
    return this.m;
  };
  Matrix4.prototype.component14 = function () {
    return this.n;
  };
  Matrix4.prototype.component15 = function () {
    return this.o;
  };
  Matrix4.prototype.component16 = function () {
    return this.p;
  };
  Matrix4.prototype.copy_8odxlg$ = function (a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p) {
    return new Matrix4(a === void 0 ? this.a : a, b === void 0 ? this.b : b, c === void 0 ? this.c : c, d === void 0 ? this.d : d, e === void 0 ? this.e : e, f === void 0 ? this.f : f, g === void 0 ? this.g : g, h === void 0 ? this.h : h, i === void 0 ? this.i : i, j === void 0 ? this.j : j, k === void 0 ? this.k : k, l === void 0 ? this.l : l, m === void 0 ? this.m : m, n === void 0 ? this.n : n, o === void 0 ? this.o : o, p === void 0 ? this.p : p);
  };
  Matrix4.prototype.toString = function () {
    return 'Matrix4(a=' + Kotlin.toString(this.a) + (', b=' + Kotlin.toString(this.b)) + (', c=' + Kotlin.toString(this.c)) + (', d=' + Kotlin.toString(this.d)) + (', e=' + Kotlin.toString(this.e)) + (', f=' + Kotlin.toString(this.f)) + (', g=' + Kotlin.toString(this.g)) + (', h=' + Kotlin.toString(this.h)) + (', i=' + Kotlin.toString(this.i)) + (', j=' + Kotlin.toString(this.j)) + (', k=' + Kotlin.toString(this.k)) + (', l=' + Kotlin.toString(this.l)) + (', m=' + Kotlin.toString(this.m)) + (', n=' + Kotlin.toString(this.n)) + (', o=' + Kotlin.toString(this.o)) + (', p=' + Kotlin.toString(this.p)) + ')';
  };
  Matrix4.prototype.hashCode = function () {
    var result = 0;
    result = result * 31 + Kotlin.hashCode(this.a) | 0;
    result = result * 31 + Kotlin.hashCode(this.b) | 0;
    result = result * 31 + Kotlin.hashCode(this.c) | 0;
    result = result * 31 + Kotlin.hashCode(this.d) | 0;
    result = result * 31 + Kotlin.hashCode(this.e) | 0;
    result = result * 31 + Kotlin.hashCode(this.f) | 0;
    result = result * 31 + Kotlin.hashCode(this.g) | 0;
    result = result * 31 + Kotlin.hashCode(this.h) | 0;
    result = result * 31 + Kotlin.hashCode(this.i) | 0;
    result = result * 31 + Kotlin.hashCode(this.j) | 0;
    result = result * 31 + Kotlin.hashCode(this.k) | 0;
    result = result * 31 + Kotlin.hashCode(this.l) | 0;
    result = result * 31 + Kotlin.hashCode(this.m) | 0;
    result = result * 31 + Kotlin.hashCode(this.n) | 0;
    result = result * 31 + Kotlin.hashCode(this.o) | 0;
    result = result * 31 + Kotlin.hashCode(this.p) | 0;
    return result;
  };
  Matrix4.prototype.equals = function (other) {
    return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && (Kotlin.equals(this.a, other.a) && Kotlin.equals(this.b, other.b) && Kotlin.equals(this.c, other.c) && Kotlin.equals(this.d, other.d) && Kotlin.equals(this.e, other.e) && Kotlin.equals(this.f, other.f) && Kotlin.equals(this.g, other.g) && Kotlin.equals(this.h, other.h) && Kotlin.equals(this.i, other.i) && Kotlin.equals(this.j, other.j) && Kotlin.equals(this.k, other.k) && Kotlin.equals(this.l, other.l) && Kotlin.equals(this.m, other.m) && Kotlin.equals(this.n, other.n) && Kotlin.equals(this.o, other.o) && Kotlin.equals(this.p, other.p)))));
  };
  function times_1($receiver, v) {
    return new Vector3($receiver.a * v.x + $receiver.b * v.y + $receiver.c * v.z + $receiver.d, $receiver.e * v.x + $receiver.f * v.y + $receiver.g * v.z + $receiver.h, $receiver.i * v.x + $receiver.j * v.y + $receiver.k * v.z + $receiver.l);
  }
  function times_2($receiver, x) {
    return new Matrix4($receiver.a * x.a + $receiver.b * x.e + $receiver.c * x.i + $receiver.d * x.m, $receiver.a * x.b + $receiver.b * x.f + $receiver.c * x.j + $receiver.d * x.n, $receiver.a * x.c + $receiver.b * x.g + $receiver.c * x.k + $receiver.d * x.o, $receiver.a * x.d + $receiver.b * x.h + $receiver.c * x.l + $receiver.d * x.p, $receiver.e * x.a + $receiver.f * x.e + $receiver.g * x.i + $receiver.h * x.m, $receiver.e * x.b + $receiver.f * x.f + $receiver.g * x.j + $receiver.h * x.n, $receiver.e * x.c + $receiver.f * x.g + $receiver.g * x.k + $receiver.h * x.o, $receiver.e * x.d + $receiver.f * x.h + $receiver.g * x.l + $receiver.h * x.p, $receiver.i * x.a + $receiver.j * x.e + $receiver.k * x.i + $receiver.l * x.m, $receiver.i * x.b + $receiver.j * x.f + $receiver.k * x.j + $receiver.l * x.n, $receiver.i * x.c + $receiver.j * x.g + $receiver.k * x.k + $receiver.l * x.o, $receiver.i * x.d + $receiver.j * x.h + $receiver.k * x.l + $receiver.l * x.p, $receiver.m * x.a + $receiver.n * x.e + $receiver.o * x.i + $receiver.p * x.m, $receiver.m * x.b + $receiver.n * x.f + $receiver.o * x.j + $receiver.p * x.n, $receiver.m * x.c + $receiver.n * x.g + $receiver.o * x.k + $receiver.p * x.o, $receiver.m * x.d + $receiver.n * x.h + $receiver.o * x.l + $receiver.p * x.p);
  }
  function translate_0($receiver, translation) {
    return times_2($receiver, Matrix4$Companion_getInstance().translation_x47bqo$(translation));
  }
  function scale_0($receiver, scale) {
    return times_2($receiver, Matrix4$Companion_getInstance().scale_x47bqo$(scale));
  }
  function Object_0(localVertices) {
    this.localVertices = localVertices;
    this.localPosition = new Vector3(0.0, 0.0, 0.0);
    this.transformation = Matrix4$Companion_getInstance().identity();
  }
  Object_0.prototype.position = function () {
    return times_1(this.transformation, this.localPosition);
  };
  var collectionSizeOrDefault = Kotlin.kotlin.collections.collectionSizeOrDefault_ba2ldo$;
  var ArrayList_init_0 = Kotlin.kotlin.collections.ArrayList_init_ww73n8$;
  Object_0.prototype.vertices = function () {
    var $receiver = this.localVertices;
    var destination = ArrayList_init_0(collectionSizeOrDefault($receiver, 10));
    var tmp$;
    tmp$ = $receiver.iterator();
    while (tmp$.hasNext()) {
      var item = tmp$.next();
      destination.add_11rb$(item.copy_fspcqd$(times_1(this.transformation, item.position)));
    }
    return destination;
  };
  var ArrayList_init_1 = Kotlin.kotlin.collections.ArrayList_init_287e2$;
  var addAll = Kotlin.kotlin.collections.addAll_ipc267$;
  var LinkedHashMap_init = Kotlin.kotlin.collections.LinkedHashMap_init_q3lmfv$;
  Object_0.prototype.render = function (program) {
    var vertices = this.vertices();
    var destination = ArrayList_init_1();
    var tmp$;
    tmp$ = vertices.iterator();
    while (tmp$.hasNext()) {
      var element = tmp$.next();
      var list = element.attributes().entries;
      addAll(destination, list);
    }
    var destination_0 = LinkedHashMap_init();
    var tmp$_0;
    tmp$_0 = destination.iterator();
    while (tmp$_0.hasNext()) {
      var element_0 = tmp$_0.next();
      var key = element_0.key;
      var tmp$_0_0;
      var value = destination_0.get_11rb$(key);
      if (value == null) {
        var answer = ArrayList_init_1();
        destination_0.put_xwzc9p$(key, answer);
        tmp$_0_0 = answer;
      }
       else {
        tmp$_0_0 = value;
      }
      var list_0 = tmp$_0_0;
      list_0.add_11rb$(element_0);
    }
    var destination_1 = ArrayList_init_0(destination_0.size);
    var tmp$_1;
    tmp$_1 = destination_0.entries.iterator();
    while (tmp$_1.hasNext()) {
      var item = tmp$_1.next();
      var tmp$_2 = destination_1.add_11rb$;
      var tmp$_3 = item.key;
      var $receiver = item.value;
      var destination_2 = ArrayList_init_1();
      var tmp$_4;
      tmp$_4 = $receiver.iterator();
      while (tmp$_4.hasNext()) {
        var element_1 = tmp$_4.next();
        var list_1 = element_1.value;
        addAll(destination_2, list_1);
      }
      tmp$_2.call(destination_1, to(tmp$_3, destination_2));
    }
    var tmp$_5;
    tmp$_5 = destination_1.iterator();
    while (tmp$_5.hasNext()) {
      var element_2 = tmp$_5.next();
      program.updateAttribute(element_2.first, element_2.second);
    }
    program.render(WebGLRenderingContext.TRIANGLES, vertices.size);
  };
  Object_0.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Object',
    interfaces: []
  };
  function Program(renderingContext, program, attributes, uniforms) {
    Program$Companion_getInstance();
    this.renderingContext = renderingContext;
    this.program = program;
    this.attributes = attributes;
    this.uniforms = uniforms;
  }
  var copyToArray = Kotlin.kotlin.collections.copyToArray;
  Program.prototype.updateAttribute = function (name, data) {
    var $receiver = ensureNotNull(this.attributes.get_11rb$(name));
    this.renderingContext.bindBuffer($receiver.type.value, $receiver.buffer);
    this.renderingContext.bufferData($receiver.type.value, new Float32Array(copyToArray(data)), WebGLRenderingContext.DYNAMIC_DRAW);
  };
  function Program$updateUniform$lambda(this$Program, closure$data) {
    return function ($receiver) {
      this$Program.stage();
      $receiver.mapper(this$Program.renderingContext, $receiver.position, closure$data);
      return Unit;
    };
  }
  Program.prototype.updateUniform = function (name, data) {
    var tmp$;
    Program$updateUniform$lambda(this, data)(Kotlin.isType(tmp$ = ensureNotNull(this.uniforms.get_11rb$(name)), UniformInfo) ? tmp$ : throwCCE());
  };
  Program.prototype.resize = function (x, y, width, height) {
    this.renderingContext.viewport(x, y, width, height);
  };
  Program.prototype.reconfigureViewport = function () {
    Program$Companion_getInstance().resize_0(this.renderingContext.canvas);
    this.resize(0, 0, this.renderingContext.canvas.width, this.renderingContext.canvas.height);
  };
  Program.prototype.stage = function () {
    this.renderingContext.useProgram(this.program);
  };
  Program.prototype.render = function (type, vertexCount) {
    var tmp$;
    tmp$ = this.attributes.values.iterator();
    while (tmp$.hasNext()) {
      var element = tmp$.next();
      this.renderingContext.bindBuffer(element.type.value, element.buffer);
      element.mapper(this.renderingContext, element.position);
    }
    this.renderingContext.enable(WebGLRenderingContext.DEPTH_TEST);
    this.renderingContext.drawArrays(type, 0, vertexCount);
  };
  Program.prototype.renderTriangles = function (vertexCount) {
    this.render(WebGLRenderingContext.TRIANGLES, vertexCount);
  };
  function Program$Companion() {
    Program$Companion_instance = this;
  }
  Program$Companion.prototype.resize_0 = function (canvas) {
    if (canvas.width !== canvas.clientWidth || canvas.height !== canvas.clientHeight) {
      canvas.width = canvas.clientWidth;
      canvas.height = canvas.clientHeight;
    }
  };
  Program$Companion.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'Companion',
    interfaces: []
  };
  var Program$Companion_instance = null;
  function Program$Companion_getInstance() {
    if (Program$Companion_instance === null) {
      new Program$Companion();
    }
    return Program$Companion_instance;
  }
  Program.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Program',
    interfaces: []
  };
  Program.prototype.component1 = function () {
    return this.renderingContext;
  };
  Program.prototype.component2 = function () {
    return this.program;
  };
  Program.prototype.component3 = function () {
    return this.attributes;
  };
  Program.prototype.component4 = function () {
    return this.uniforms;
  };
  Program.prototype.copy_b3xh8h$ = function (renderingContext, program, attributes, uniforms) {
    return new Program(renderingContext === void 0 ? this.renderingContext : renderingContext, program === void 0 ? this.program : program, attributes === void 0 ? this.attributes : attributes, uniforms === void 0 ? this.uniforms : uniforms);
  };
  Program.prototype.toString = function () {
    return 'Program(renderingContext=' + Kotlin.toString(this.renderingContext) + (', program=' + Kotlin.toString(this.program)) + (', attributes=' + Kotlin.toString(this.attributes)) + (', uniforms=' + Kotlin.toString(this.uniforms)) + ')';
  };
  Program.prototype.hashCode = function () {
    var result = 0;
    result = result * 31 + Kotlin.hashCode(this.renderingContext) | 0;
    result = result * 31 + Kotlin.hashCode(this.program) | 0;
    result = result * 31 + Kotlin.hashCode(this.attributes) | 0;
    result = result * 31 + Kotlin.hashCode(this.uniforms) | 0;
    return result;
  };
  Program.prototype.equals = function (other) {
    return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && (Kotlin.equals(this.renderingContext, other.renderingContext) && Kotlin.equals(this.program, other.program) && Kotlin.equals(this.attributes, other.attributes) && Kotlin.equals(this.uniforms, other.uniforms)))));
  };
  function simpleProgramFrom(renderingContext) {
    return programFrom(renderingContext, simpleVertexShader, simpleFragmentShader, vertex3dAttributeMappings());
  }
  function programFrom(renderingContext, vertexShader, fragmentShader, attributes, uniforms) {
    if (uniforms === void 0)
      uniforms = emptyList();
    var program_0 = program(renderingContext, listOf([shader(renderingContext, WebGLRenderingContext.FRAGMENT_SHADER, fragmentShader), shader(renderingContext, WebGLRenderingContext.VERTEX_SHADER, vertexShader)]));
    var destination = ArrayList_init_0(collectionSizeOrDefault(attributes, 10));
    var tmp$;
    tmp$ = attributes.iterator();
    while (tmp$.hasNext()) {
      var item = tmp$.next();
      destination.add_11rb$(to(item.name, attribute(renderingContext, program_0, item)));
    }
    var tmp$_0 = toMap(destination);
    var destination_0 = ArrayList_init_0(collectionSizeOrDefault(uniforms, 10));
    var tmp$_1;
    tmp$_1 = uniforms.iterator();
    while (tmp$_1.hasNext()) {
      var item_0 = tmp$_1.next();
      destination_0.add_11rb$(to(item_0.name, uniform(renderingContext, program_0, item_0)));
    }
    return new Program(renderingContext, program_0, tmp$_0, toMap(destination_0));
  }
  function shader($receiver, type, source) {
    var $receiver_0 = $receiver.createShader(type);
    $receiver.shaderSource($receiver_0, source);
    $receiver.compileShader($receiver_0);
    if (equals($receiver.getShaderParameter($receiver_0, WebGLRenderingContext.COMPILE_STATUS), false)) {
      $receiver.deleteShader($receiver_0);
      throw Error_init('Could not create shader of type ' + type);
    }
    return ensureNotNull($receiver_0);
  }
  function program($receiver, shaders) {
    var $receiver_0 = $receiver.createProgram();
    var tmp$;
    tmp$ = shaders.iterator();
    while (tmp$.hasNext()) {
      var element = tmp$.next();
      $receiver.attachShader($receiver_0, element);
    }
    $receiver.linkProgram($receiver_0);
    if (equals($receiver.getProgramParameter($receiver_0, WebGLRenderingContext.LINK_STATUS), false)) {
      $receiver.deleteProgram($receiver_0);
      throw Error_init('Could not create program');
    }
    return ensureNotNull($receiver_0);
  }
  function attribute($receiver, program, attribute) {
    var position = $receiver.getAttribLocation(program, attribute.name);
    var buffer = ensureNotNull($receiver.createBuffer());
    $receiver.bindBuffer(attribute.type.value, buffer);
    $receiver.enableVertexAttribArray(position);
    return new AttributeInfo(attribute.name, position, attribute.type, buffer, attribute.mapper);
  }
  function uniform($receiver, program, uniform) {
    return new UniformInfo(uniform.name, ensureNotNull($receiver.getUniformLocation(program, uniform.name)), uniform.mapper);
  }
  var simpleVertexShader;
  var simpleFragmentShader;
  function Scene(objects) {
    this.objects = objects;
  }
  Scene.prototype.render = function (program) {
    program.reconfigureViewport();
    var tmp$;
    tmp$ = this.objects.iterator();
    while (tmp$.hasNext()) {
      var element = tmp$.next();
      element.render(program);
    }
  };
  Scene.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Scene',
    interfaces: []
  };
  Scene.prototype.component1 = function () {
    return this.objects;
  };
  Scene.prototype.copy_ajfl5g$ = function (objects) {
    return new Scene(objects === void 0 ? this.objects : objects);
  };
  Scene.prototype.toString = function () {
    return 'Scene(objects=' + Kotlin.toString(this.objects) + ')';
  };
  Scene.prototype.hashCode = function () {
    var result = 0;
    result = result * 31 + Kotlin.hashCode(this.objects) | 0;
    return result;
  };
  Scene.prototype.equals = function (other) {
    return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && Kotlin.equals(this.objects, other.objects))));
  };
  function Triangle(a, b, c) {
    Object_0.call(this, listOf([a, b, c]));
    this.a = a;
    this.b = b;
    this.c = c;
  }
  Triangle.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Triangle',
    interfaces: [Object_0]
  };
  Triangle.prototype.component1 = function () {
    return this.a;
  };
  Triangle.prototype.component2 = function () {
    return this.b;
  };
  Triangle.prototype.component3 = function () {
    return this.c;
  };
  Triangle.prototype.copy_a8zoz9$ = function (a, b, c) {
    return new Triangle(a === void 0 ? this.a : a, b === void 0 ? this.b : b, c === void 0 ? this.c : c);
  };
  Triangle.prototype.toString = function () {
    return 'Triangle(a=' + Kotlin.toString(this.a) + (', b=' + Kotlin.toString(this.b)) + (', c=' + Kotlin.toString(this.c)) + ')';
  };
  Triangle.prototype.hashCode = function () {
    var result = 0;
    result = result * 31 + Kotlin.hashCode(this.a) | 0;
    result = result * 31 + Kotlin.hashCode(this.b) | 0;
    result = result * 31 + Kotlin.hashCode(this.c) | 0;
    return result;
  };
  Triangle.prototype.equals = function (other) {
    return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && (Kotlin.equals(this.a, other.a) && Kotlin.equals(this.b, other.b) && Kotlin.equals(this.c, other.c)))));
  };
  function UniformInfo(name, position, mapper) {
    this.name = name;
    this.position = position;
    this.mapper = mapper;
  }
  UniformInfo.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'UniformInfo',
    interfaces: []
  };
  UniformInfo.prototype.component1 = function () {
    return this.name;
  };
  UniformInfo.prototype.component2 = function () {
    return this.position;
  };
  UniformInfo.prototype.component3 = function () {
    return this.mapper;
  };
  UniformInfo.prototype.copy_yc28gz$ = function (name, position, mapper) {
    return new UniformInfo(name === void 0 ? this.name : name, position === void 0 ? this.position : position, mapper === void 0 ? this.mapper : mapper);
  };
  UniformInfo.prototype.toString = function () {
    return 'UniformInfo(name=' + Kotlin.toString(this.name) + (', position=' + Kotlin.toString(this.position)) + (', mapper=' + Kotlin.toString(this.mapper)) + ')';
  };
  UniformInfo.prototype.hashCode = function () {
    var result = 0;
    result = result * 31 + Kotlin.hashCode(this.name) | 0;
    result = result * 31 + Kotlin.hashCode(this.position) | 0;
    result = result * 31 + Kotlin.hashCode(this.mapper) | 0;
    return result;
  };
  UniformInfo.prototype.equals = function (other) {
    return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && (Kotlin.equals(this.name, other.name) && Kotlin.equals(this.position, other.position) && Kotlin.equals(this.mapper, other.mapper)))));
  };
  function Uniform(name, mapper) {
    this.name = name;
    this.mapper = mapper;
  }
  Uniform.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Uniform',
    interfaces: []
  };
  Uniform.prototype.component1 = function () {
    return this.name;
  };
  Uniform.prototype.component2 = function () {
    return this.mapper;
  };
  Uniform.prototype.copy_5ca8s2$ = function (name, mapper) {
    return new Uniform(name === void 0 ? this.name : name, mapper === void 0 ? this.mapper : mapper);
  };
  Uniform.prototype.toString = function () {
    return 'Uniform(name=' + Kotlin.toString(this.name) + (', mapper=' + Kotlin.toString(this.mapper)) + ')';
  };
  Uniform.prototype.hashCode = function () {
    var result = 0;
    result = result * 31 + Kotlin.hashCode(this.name) | 0;
    result = result * 31 + Kotlin.hashCode(this.mapper) | 0;
    return result;
  };
  Uniform.prototype.equals = function (other) {
    return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && (Kotlin.equals(this.name, other.name) && Kotlin.equals(this.mapper, other.mapper)))));
  };
  function Vector() {
  }
  var Math_0 = Math;
  Vector.prototype.calculateLength = function () {
    var x = this.dot(this);
    return Math_0.sqrt(x);
  };
  Vector.$metadata$ = {
    kind: Kind_INTERFACE,
    simpleName: 'Vector',
    interfaces: []
  };
  function InvalidVectorOperation(dimensions) {
    IllegalArgumentException_init('This operation is invalid, may only operate on Vector' + dimensions, this);
    this.name = 'InvalidVectorOperation';
  }
  InvalidVectorOperation.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'InvalidVectorOperation',
    interfaces: [IllegalArgumentException]
  };
  function Vector2(x, y) {
    this.x = x;
    this.y = y;
    this._length_0 = null;
  }
  Vector2.prototype.plus = function (other) {
    return new Vector2(this.x + other.x, this.y + other.y);
  };
  Vector2.prototype.minus = function (other) {
    return new Vector2(this.x - other.x, this.y - other.y);
  };
  Vector2.prototype.scale = function (scale) {
    return new Vector2(this.x * scale.x, this.y * scale.y);
  };
  Vector2.prototype.scaleUniformly = function (scale) {
    return new Vector2(this.x * scale, this.y * scale);
  };
  Vector2.prototype.dot = function (other) {
    if (Kotlin.isType(other, Vector2))
      return this.x * other.x + this.y * other.y;
    else
      throw new InvalidVectorOperation(2);
  };
  Vector2.prototype.length = function () {
    if (this._length_0 == null)
      this._length_0 = this.calculateLength();
    return ensureNotNull(this._length_0);
  };
  Vector2.prototype.components = function () {
    return listOf([this.x, this.y]);
  };
  Vector2.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Vector2',
    interfaces: [Vector]
  };
  Vector2.prototype.component1 = function () {
    return this.x;
  };
  Vector2.prototype.component2 = function () {
    return this.y;
  };
  Vector2.prototype.copy_dleff0$ = function (x, y) {
    return new Vector2(x === void 0 ? this.x : x, y === void 0 ? this.y : y);
  };
  Vector2.prototype.toString = function () {
    return 'Vector2(x=' + Kotlin.toString(this.x) + (', y=' + Kotlin.toString(this.y)) + ')';
  };
  Vector2.prototype.hashCode = function () {
    var result = 0;
    result = result * 31 + Kotlin.hashCode(this.x) | 0;
    result = result * 31 + Kotlin.hashCode(this.y) | 0;
    return result;
  };
  Vector2.prototype.equals = function (other) {
    return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && (Kotlin.equals(this.x, other.x) && Kotlin.equals(this.y, other.y)))));
  };
  function Vector3(x, y, z) {
    this.x = x;
    this.y = y;
    this.z = z;
    this._length_0 = null;
  }
  Vector3.prototype.plus = function (other) {
    return new Vector3(this.x + other.x, this.y + other.y, this.z + other.z);
  };
  Vector3.prototype.minus = function (other) {
    return new Vector3(this.x - other.x, this.y - other.y, this.z - other.z);
  };
  Vector3.prototype.scale = function (scale) {
    return new Vector3(this.x * scale.x, this.y * scale.y, this.z * scale.z);
  };
  Vector3.prototype.scaleUniformly = function (scale) {
    return new Vector3(this.x * scale, this.y * scale, this.z * scale);
  };
  Vector3.prototype.dot = function (other) {
    if (Kotlin.isType(other, Vector3))
      return this.x * other.x + this.y * other.y + this.z * other.z;
    else
      throw new InvalidVectorOperation(3);
  };
  Vector3.prototype.length = function () {
    if (this._length_0 == null)
      this._length_0 = this.calculateLength();
    return ensureNotNull(this._length_0);
  };
  Vector3.prototype.components = function () {
    return listOf([this.x, this.y, this.z]);
  };
  Vector3.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Vector3',
    interfaces: [Vector]
  };
  Vector3.prototype.component1 = function () {
    return this.x;
  };
  Vector3.prototype.component2 = function () {
    return this.y;
  };
  Vector3.prototype.component3 = function () {
    return this.z;
  };
  Vector3.prototype.copy_y2kzbl$ = function (x, y, z) {
    return new Vector3(x === void 0 ? this.x : x, y === void 0 ? this.y : y, z === void 0 ? this.z : z);
  };
  Vector3.prototype.toString = function () {
    return 'Vector3(x=' + Kotlin.toString(this.x) + (', y=' + Kotlin.toString(this.y)) + (', z=' + Kotlin.toString(this.z)) + ')';
  };
  Vector3.prototype.hashCode = function () {
    var result = 0;
    result = result * 31 + Kotlin.hashCode(this.x) | 0;
    result = result * 31 + Kotlin.hashCode(this.y) | 0;
    result = result * 31 + Kotlin.hashCode(this.z) | 0;
    return result;
  };
  Vector3.prototype.equals = function (other) {
    return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && (Kotlin.equals(this.x, other.x) && Kotlin.equals(this.y, other.y) && Kotlin.equals(this.z, other.z)))));
  };
  function Vector4(r, g, b, a) {
    this.r = r;
    this.g = g;
    this.b = b;
    this.a = a;
    this._length_0 = null;
  }
  Vector4.prototype.plus = function (other) {
    return new Vector4(this.r + other.r, this.g + other.g, this.b + other.b, this.a + other.a);
  };
  Vector4.prototype.minus = function (other) {
    return new Vector4(this.r - other.r, this.g - other.g, this.b - other.b, this.a - other.a);
  };
  Vector4.prototype.scale = function (scale) {
    return new Vector4(this.r * scale.r, this.g * scale.g, this.b * scale.b, this.a * scale.a);
  };
  Vector4.prototype.scaleUniformly = function (scale) {
    return new Vector4(this.r * scale, this.g * scale, this.b * scale, this.a * scale);
  };
  Vector4.prototype.dot = function (other) {
    if (Kotlin.isType(other, Vector4))
      return this.r * other.r + this.g * other.g + this.b * other.b + this.a * other.a;
    else
      throw new InvalidVectorOperation(4);
  };
  Vector4.prototype.length = function () {
    if (this._length_0 == null)
      this._length_0 = this.calculateLength();
    return ensureNotNull(this._length_0);
  };
  Vector4.prototype.components = function () {
    return listOf([this.r, this.g, this.b, this.a]);
  };
  Vector4.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Vector4',
    interfaces: [Vector]
  };
  Vector4.prototype.component1 = function () {
    return this.r;
  };
  Vector4.prototype.component2 = function () {
    return this.g;
  };
  Vector4.prototype.component3 = function () {
    return this.b;
  };
  Vector4.prototype.component4 = function () {
    return this.a;
  };
  Vector4.prototype.copy_7b5o5w$ = function (r, g, b, a) {
    return new Vector4(r === void 0 ? this.r : r, g === void 0 ? this.g : g, b === void 0 ? this.b : b, a === void 0 ? this.a : a);
  };
  Vector4.prototype.toString = function () {
    return 'Vector4(r=' + Kotlin.toString(this.r) + (', g=' + Kotlin.toString(this.g)) + (', b=' + Kotlin.toString(this.b)) + (', a=' + Kotlin.toString(this.a)) + ')';
  };
  Vector4.prototype.hashCode = function () {
    var result = 0;
    result = result * 31 + Kotlin.hashCode(this.r) | 0;
    result = result * 31 + Kotlin.hashCode(this.g) | 0;
    result = result * 31 + Kotlin.hashCode(this.b) | 0;
    result = result * 31 + Kotlin.hashCode(this.a) | 0;
    return result;
  };
  Vector4.prototype.equals = function (other) {
    return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && (Kotlin.equals(this.r, other.r) && Kotlin.equals(this.g, other.g) && Kotlin.equals(this.b, other.b) && Kotlin.equals(this.a, other.a)))));
  };
  function Vertex3d(position, color) {
    if (position === void 0)
      position = new Vector3(0.0, 0.0, 0.0);
    if (color === void 0)
      color = new Vector4(0.0, 0.0, 0.0, 1.0);
    this.position = position;
    this.color = color;
  }
  Vertex3d.prototype.attributes = function () {
    return mapOf([to('vertex_position', this.position.components()), to('vertex_color', this.color.components())]);
  };
  Vertex3d.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Vertex3d',
    interfaces: []
  };
  Vertex3d.prototype.component1 = function () {
    return this.position;
  };
  Vertex3d.prototype.component2 = function () {
    return this.color;
  };
  Vertex3d.prototype.copy_fspcqd$ = function (position, color) {
    return new Vertex3d(position === void 0 ? this.position : position, color === void 0 ? this.color : color);
  };
  Vertex3d.prototype.toString = function () {
    return 'Vertex3d(position=' + Kotlin.toString(this.position) + (', color=' + Kotlin.toString(this.color)) + ')';
  };
  Vertex3d.prototype.hashCode = function () {
    var result = 0;
    result = result * 31 + Kotlin.hashCode(this.position) | 0;
    result = result * 31 + Kotlin.hashCode(this.color) | 0;
    return result;
  };
  Vertex3d.prototype.equals = function (other) {
    return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && (Kotlin.equals(this.position, other.position) && Kotlin.equals(this.color, other.color)))));
  };
  function vertex3dAttributeMappings$lambda(context, position) {
    context.vertexAttribPointer(position, 3, WebGLRenderingContext.FLOAT, false, 0, 0);
    return Unit;
  }
  function vertex3dAttributeMappings$lambda_0(context, position) {
    context.vertexAttribPointer(position, 4, WebGLRenderingContext.FLOAT, false, 0, 0);
    return Unit;
  }
  function vertex3dAttributeMappings() {
    return listOf([new Attribute('vertex_position', AttributeType$ARRAY_BUFFER_getInstance(), vertex3dAttributeMappings$lambda), new Attribute('vertex_color', AttributeType$ARRAY_BUFFER_getInstance(), vertex3dAttributeMappings$lambda_0)]);
  }
  Object.defineProperty(AttributeType, 'ARRAY_BUFFER', {
    get: AttributeType$ARRAY_BUFFER_getInstance
  });
  _.AttributeType = AttributeType;
  _.Attribute = Attribute;
  _.AttributeInfo = AttributeInfo;
  Object.defineProperty(Matrix3, 'Companion', {
    get: Matrix3$Companion_getInstance
  });
  _.Matrix3_init_pcaoge$ = Matrix3_init;
  _.Matrix3 = Matrix3;
  _.Identity2d = Matrix3Identity;
  _.Translation2d = Matrix3Translation;
  _.Scale2d = Matrix3Scale;
  _.transpose_67jful$ = transpose;
  _.adjugate_67jful$ = adjugate;
  _.inverse_67jful$ = inverse;
  _.div_lu5ks4$ = div;
  _.times_gmn1im$ = times;
  _.times_8auvcb$ = times_0;
  _.translate_gmn1im$ = translate;
  _.scale_gmn1im$ = scale;
  Object.defineProperty(Matrix4, 'Companion', {
    get: Matrix4$Companion_getInstance
  });
  _.Matrix4 = Matrix4;
  _.times_oiczo4$ = times_1;
  _.times_wu55uf$ = times_2;
  _.translate_oiczo4$ = translate_0;
  _.scale_oiczo4$ = scale_0;
  _.Object = Object_0;
  Object.defineProperty(Program, 'Companion', {
    get: Program$Companion_getInstance
  });
  _.Program = Program;
  _.simpleProgramFrom = simpleProgramFrom;
  _.programFrom = programFrom;
  _.shader_q1ce10$ = shader;
  _.program_vy0gm8$ = program;
  _.attribute_3e5dig$ = attribute;
  _.uniform_jshdel$ = uniform;
  Object.defineProperty(_, 'simpleVertexShader', {
    get: function () {
      return simpleVertexShader;
    }
  });
  Object.defineProperty(_, 'simpleFragmentShader', {
    get: function () {
      return simpleFragmentShader;
    }
  });
  _.Scene = Scene;
  _.Triangle = Triangle;
  _.UniformInfo = UniformInfo;
  _.Uniform = Uniform;
  _.Vector = Vector;
  _.InvalidVectorOperation = InvalidVectorOperation;
  _.Vector2 = Vector2;
  _.Vector3 = Vector3;
  _.Vector4 = Vector4;
  _.Vertex3d = Vertex3d;
  _.vertex3dAttributeMappings = vertex3dAttributeMappings;
  Vector2.prototype.calculateLength = Vector.prototype.calculateLength;
  Vector3.prototype.calculateLength = Vector.prototype.calculateLength;
  Vector4.prototype.calculateLength = Vector.prototype.calculateLength;
  simpleVertexShader = 'attribute vec4 vertex_position;\n' + 'attribute vec4 vertex_color;\n' + 'varying vec4 pixelColor;\n' + 'void main() {\n' + '    vec4 pos = vertex_position;\n' + '    pixelColor = vertex_color;\n' + '    gl_Position = pos;\n' + '}';
  simpleFragmentShader = 'precision mediump float;\n' + 'varying vec4 pixelColor;\n' + 'void main() {\n' + '    gl_FragColor = pixelColor; \n' + '}';
  Kotlin.defineModule('simple-gl', _);
  return _;
}(module.exports, require('kotlin')));

//# sourceMappingURL=simple-gl.js.map
